VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHooker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'hooker
'Copyright (C)2001 2extreme productions (dispressa@hotmail.com)
'Major credits & inspiration Text Hack by Your God (yourgod@acdev.org)
'Source code is available from http://dispressa.tripod.com/hooker
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
'
' v0.1 9/14/01
' WHAT'S A HOOKER?
'
' What hooker does -- it scans all input typed by the user in the chat bar for a
'   line beginning with "/D". It will then echo that line to the chat window with
'   in a selected color. Also note that previously mentioned line of chat is NOT
'   spoken out loud for all the world to hear.
'
' WHY DO I CARE?
' ok fine. that's what it does. but why do i care? why is it useful?
' as it so happens, hooker will catch ANYTHING put into the char bar, whether typed by
'   the user, or generated by an extrnal macro program like ACScript. So hooker becomes
'   a simple communications mechanism by which ACScript can, (through the use of the fSay()
'   function of the acscriplib) write something to the AC chat window that the USER can see ...
'   ... but is not shouted for all the world to hear. So go change your ACScript macros to
'   fSay("/D Mana Potions Complete")
'     rather than
'   ac.debug("Mana Potions Complete")
'  this is probably the simplest plugin anyone would ever write .. but it works for me.
'
' ANYTHING ELSE?
' not really. the hook text and color is settable through an ingame decal control, as well as
'   a master enable/disable check box. note that while the enable/disable checkbox is effective
'   immediately upon clicking, any changes to the hook text and text color boxes are NOT applied
'   until the "SAVE AND APPLY" button is pushed.
'
' possible bugs: does/how does she interfere with other plugins using the same hook text?
'
' possible enhancements
'  * multiple hooks with different colors
'  * validate hook text and text color immediately upon change, rather than upon button press
'  * work with ACScript to add a parameter to the ac.debug function to "output as fSay"
'
'
' enjoy,
'
'  -di
'

Option Explicit
Option Compare Text

Implements IPlugin
Implements IPluginSink

Private PluginSite As IPluginSite
Private MainView As View
Private ViewSchema As String

' my controls
Private WithEvents chkEnabled As decalcontrols.CheckBox
Attribute chkEnabled.VB_VarHelpID = -1
Private WithEvents txtHook As decalcontrols.Edit
Attribute txtHook.VB_VarHelpID = -1
Private WithEvents txtColor As decalcontrols.Edit
Attribute txtColor.VB_VarHelpID = -1
Private WithEvents btnSave As decalcontrols.PushButton
Attribute btnSave.VB_VarHelpID = -1

' local vars
Private hookText As String
Private lenHookText As String
Private hookColor As Long
Private defaultColor As Long
Private Reg As RegOp

Private Const DEFHOOKSTRING = "/D"
Private Const DEFHOOKCOLOR = 3


Private Sub btnSave_Accepted(ByVal nID As Long)
    Dim tmpHookText As String
    Dim tmpColorText As String
    
    'WTC "before text", 3
    ' validate the decal control values
    tmpHookText = txtHook.Text
    hookText = validHookText(tmpHookText)
    
    'WTC "before color", 3
    tmpColorText = txtColor.Text
    hookColor = validHookColor(tmpColorText)
    'WTC "after color", 3
    
    ' save to registry
    Reg.Value("Enabled") = chkEnabled.Checked
    Reg.Value("txtHook") = hookText
    Reg.Value("lngColor") = hookColor
    
    ' write back to control
    txtHook.Text = hookText
    txtColor.Text = CStr(hookColor)
    
    'WTC "New Settings Saved", 3
End Sub

Private Property Get IPlugin_FriendlyName() As String
  IPlugin_FriendlyName = "hooker v" & App.Major & "." & App.Minor & "." & App.Revision
End Property

Private Sub IPlugin_Initialize(ByVal pSite As DecalPlugins.IPluginSite, ByVal nID As Long)
    ViewSchema = "<?xml version=""1.0""?>"
    ViewSchema = ViewSchema & "<view icon=""6578"" title=""hooker"" top=""50"" left=""50"" width=""180"" height=""150"">"
    ViewSchema = ViewSchema & "<control progid=""DecalControls.FixedLayout"">"
    ViewSchema = ViewSchema & "<control progid=""DecalControls.Checkbox""     name=""chkEnabled""      left=""10""   top=""10""  width=""190"" height=""18"" text=""Enabled""/>"
    ViewSchema = ViewSchema & "<control progid=""DecalControls.Edit""         name=""txtHook""         left=""10""  top=""30""  width=""90""  height=""18"" text=""Decal"" imageportalsrc=""693"" textcolor=""16777215"" />"
    ViewSchema = ViewSchema & "<control progid=""DecalControls.StaticText""   text=""Hook String""     left=""110""  top=""30""   width=""70""  height=""18"" />"
    ViewSchema = ViewSchema & "<control progid=""DecalControls.Edit""         name=""txtColor""         left=""10""  top=""50""  width=""30""  height=""18"" text=""3"" imageportalsrc=""693"" textcolor=""16777215"" />"
    ViewSchema = ViewSchema & "<control progid=""DecalControls.StaticText""   text=""Hook Color""      left=""110""  top=""50""   width=""70""  height=""18"" />"
    ViewSchema = ViewSchema & "<control progid=""DecalControls.PushButton""   name=""btnSave"" left=""50"" top=""70"" width=""80"" height=""30"" text=""Apply and Save""/>"
    ViewSchema = ViewSchema & "</control>"
    ViewSchema = ViewSchema & "</view>"
    
    ' main items used
    Set PluginSite = pSite
    Set MainView = PluginSite.LoadView(ViewSchema)
    Set Reg = New RegOp
    
    ' bind the decal controls
    Set chkEnabled = MainView.Control("chkEnabled")
    Set txtHook = MainView.Control("txtHook")
    Set txtColor = MainView.Control("txtColor")
    Set btnSave = MainView.Control("btnSave")
    
    ' read reg values
    Reg.Root = HKEY_LOCAL_MACHINE
    Reg.Key = "Software\Decal Plugins\hooker"
    chkEnabled.Checked = CBool(Reg.Value("Enabled"))
    hookText = CStr(Reg.Value("txtHook"))
    hookColor = CLng(Reg.Value("lngColor"))
    
    ' validate the data
    hookText = validHookText(hookText)
    hookColor = validHookColor(hookColor)
    
    ' update the decal controls
    txtHook.Text = hookText
    txtColor.Text = CStr(hookColor)
    
End Sub

Private Function validHookColor(ByVal varIn As Variant) As Long
    Dim newCol As Long
    On Error GoTo EH
    'WTC "chc IN:" & CStr(varIn), 3
    'WTC "chc carType:" & VarType(varIn), 3
    newCol = CLng(varIn)
    'WTC "chc newCol:" & newCol, 3
    On Error GoTo 0
    
    Select Case newCol
    Case 1 To 23
        'WTC "case 1 - 23" & newCol, 3
        validHookColor = newCol
    Case Else
        validHookColor = DEFHOOKCOLOR
    End Select
    
    'WTC "New valid hook color is:" & CStr(validHookColor), 3
    
    Exit Function

EH:
    ' the likely error is thrown by CLng if non-numeric value is set,
    '   go ahead and set newCol back to the default color.
    ' may want to check for type mismatch here for robustness
    newCol = DEFHOOKCOLOR
    Resume Next
    
End Function

Private Function validHookText(ByVal strIn As String) As String
    Dim strOut As String
    
    ' len(strIn)=0 is quicker test for null string.
    ' if i feel industrious, i might add a filter to disqualify "known commands" here
    If (Len(strIn) = 0) Or (strIn = "/") Then
       strOut = DEFHOOKSTRING
    Else
        If Left$(strIn, 1) <> "/" Then
            strOut = "/" & strIn
        Else
            strOut = strIn
        End If
    End If
    validHookText = strOut
    lenHookText = Len(validHookText)
    'WTC "New valid hook text is:" & CStr(validHookText), 3
    'WTC "New valid hook text length:" & CStr(lenHookText), 3

End Function

Private Sub IPlugin_Terminate()
  Dim RetVal As Long
  Set PluginSite = Nothing
  Set Reg = Nothing
End Sub

Private Function IPluginSink_ChatMessage(ByVal bstrMsg As String, pColor As Long) As Boolean
    ' nothing here ... but it's a need to implement
End Function

Private Function IPluginSink_ChatText(ByVal bstrMsg As String) As Boolean
    If chkEnabled.Checked Then
        Dim i As Integer
        Dim j As Integer
        Dim s As String
        
        ' HIGHTLIGHT THE DEBUG STRING
        If Left$(bstrMsg, lenHookText) = hookText Then
            s = Right$(bstrMsg, Len(bstrMsg) - lenHookText)
            WTC "Hooked:" & s, hookColor
            Exit Function
        End If
    End If
End Function

Private Sub WTC(pString As String, Optional pColor As Long = 1, Optional pLineFeed As Boolean = True)
    Dim strHold As String
    strHold = pString
    If pLineFeed Then strHold = strHold + vbLf
    PluginSite.RawWriteToChatWindow strHold, pColor
End Sub
